#!/usr/bin/env python3.9

from pathlib import Path
from rich import print
from subprocess import run


print("[dim]$[/]", *["cd", str(Path(__file__).parent)])
run(' '.join(["cd", str(Path(__file__).parent)]), shell=True)
print("[dim]$[/]", *["ssh", "ubuntu@ewen.works", "'cd ~user-data/www/media.ewen.works/mpsi && tree -f > tree.txt'"])
run(' '.join(["ssh", "ubuntu@ewen.works", "'cd ~user-data/www/media.ewen.works/mpsi && tree -f > tree.txt'"]), shell=True)
print("[dim]$[/]", *["wget", "media.ewen.works/mpsi/tree.txt", "-O tree.txt.1", "-q"])
run(' '.join(["wget", "media.ewen.works/mpsi/tree.txt", "-O tree.txt.1", "-q"]), shell=True)
print("[dim]$[/]", "tree -f > tree.txt")
run("tree -f > tree.txt", shell=True)


local = Path(__file__).parent / "tree.txt"
server = Path(__file__).parent / "tree.txt.1"

def remove_asciiart(line: str) -> str:
    if ' -> ' in line:
        return ''
    if 'directories' in line and 'files' in line:
        return ''
    cutset = "└──├──│\t\n"
    line = line.replace('./', '')
    for char in cutset:
        line = line.replace(char, '')
    if line.strip() == 'tree.txt.1':
        return ''
    return line.strip()


serverpaths = set(map(remove_asciiart, server.open().readlines()))
localpaths = set(map(remove_asciiart, local.open().readlines()))

print("Local only:  ", localpaths - serverpaths)
print("Server only: ", serverpaths - localpaths)

print("[dim]$[/] rm tree.txt tree.txt.1")
run("rm tree.txt tree.txt.1", shell=True)
print("[dim]$[/] ssh ubuntu@ewen.works 'rm ~user-data/www/media.ewen.works/mpsi/tree.txt'")
run("ssh ubuntu@ewen.works 'rm ~user-data/www/media.ewen.works/mpsi/tree.txt'", shell=True)
